Public Class FormMain
    Dim file As String = "Telefonliste.xml"
    Dim cm As CurrencyManager
    Dim dv As DataView
    Dim Picco As Boolean

    Private Sub FormMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Picco = True

        Ds2.ReadXml(file, XmlReadMode.InferSchema)
        cm = CType(BindingContext(Ds2, "Adressen"), CurrencyManager)
        dv = CType(cm.List, DataView)
        m_Datagrid.DataSource = Ds2
        m_Datagrid.DataMember = "Adressen"

        TextBox6.DataBindings.Add(New Binding("Text", Ds2, "Adressen.Bild"))
        TextBox5.DataBindings.Add(New Binding("Text", Ds2, "Adressen.TelNr"))
        TextBox4.DataBindings.Add(New Binding("Text", Ds2, "Adressen.Ort"))
        TextBox3.DataBindings.Add(New Binding("Text", Ds2, "Adressen.Vorname"))
        TextBox2.DataBindings.Add(New Binding("Text", Ds2, "Adressen.Name"))

        Navigation()
    End Sub

    Private Sub Navigation()
        Me.lblNavLocation.Text = Me.BindingContext(dv).Count.ToString & "  Datenstze"
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        m_Datagrid.Focus()
        m_Datagrid.Refresh()
        m_Datagrid.SetDataBinding(Ds2, "Adressen")
        Ds2.WriteXml(file)
        Picco = True
        Navigation()
    End Sub

    Private Sub Button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If TextBox1.Text = "" Then
            MessageBox.Show("Bitte Filterbegriff eingeben!", "", MessageBoxButtons.OK, MessageBoxIcon.Error)

        Else
            If RadioButton1.Checked Then
                dv.RowFilter = "Name LIKE '%" + TextBox1.Text + "%'"

            Else
                dv.RowFilter = "Vorname LIKE '%" + TextBox1.Text + "%'"

            End If
        End If
        Navigation()
    End Sub

    Private Sub Button3_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        dv.RowFilter = ""
        Navigation()
    End Sub

    Private Sub FormMain_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Application.Exit()
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        TextBox2.Focus()
        Picco = False
        cm.AddNew()
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim msg As String = "Wollen Sie den Datensatz " & TextBox2.Text & " wirklich lschen?"
        Dim cpt As String = "Datensatz lschen"
        If MessageBox.Show(msg, cpt, MessageBoxButtons.YesNo, MessageBoxIcon.Question) _
                 = Windows.Forms.DialogResult.Yes Then
            cm.RemoveAt(m_Datagrid.CurrentRowIndex)

            Ds2.WriteXml(file)
            Navigation()

        Else
            MessageBox.Show("Dann eben nicht!", "", MessageBoxButtons.OK, MessageBoxIcon.Asterisk)
        End If

    End Sub

    Private Sub btnNavNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNavNext.Click
        cm.Position += 1  ' >
    End Sub

    Private Sub btnNavPrev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNavPrev.Click
        cm.Position -= 1
    End Sub

    Private Sub btnLast_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLast.Click
        cm.Position = cm.Count - 1  ' >|
    End Sub

    Private Sub btnNavFirst_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNavFirst.Click
        cm.Position = 0   ' |<
    End Sub

    Private Sub TextBox2_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox2.LostFocus
        m_Datagrid.Refresh()
    End Sub

   Private Sub TextBox3_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox3.LostFocus
        m_Datagrid.Refresh()
    End Sub

    Private Sub TextBox4_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox4.LostFocus
        m_Datagrid.Refresh()
    End Sub

    Private Sub TextBox5_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox5.LostFocus
        m_Datagrid.Refresh()
    End Sub

    Private Sub TextBox6_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox6.LostFocus
        m_Datagrid.Refresh()
    End Sub

    Private Sub TextBox6_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox6.TextChanged
        If Picco = True Then
            PictureBox1.Image = Image.FromFile(TextBox6.Text)
        Else : Exit Sub
        End If
    End Sub
End Class